version: '3'
services:
  solr:
    image: solr:7.7.1
    ports:
     - "8984:8983"
    restart: unless-stopped
    volumes:
      - ./solr/solr-7.3.0/server/solr-webapp/webapp/WEB-INF/lib:/opt/solr/server/solr-webapp/webapp/WEB-INF/lib/
      - ./solr/solr-7.3.0/server/solr/species:/opt/solr/server/solr/species:rw
      - ./solr/solr-7.3.0/server/solr/urban-forest:/opt/solr/server/solr/urban-forest:rw
    networks:
      - urbanforest-network

  backend:
    build: ./web/backend
    volumes:
      - ./web/backend:/app/backend
      - ./data:/data
    ports:
      - "8000:8000"
      - "5443:443"
    tty: true
    restart: unless-stopped
    container_name: urbanforest_backend
    depends_on:
     - solr
    networks:
      - urbanforest-network
  
  frontend:
    build: 
      context: ./web/frontend
      dockerfile: Dockerfile-prod
    volumes:
      - ./web/frontend:/app/
       #One-way volume to use node_modules from inside image
      - /app/node_modules
    ports:
      - "3010:80"
    container_name: urbanforest_frontend
    depends_on:
      - backend
    restart: unless-stopped
    networks:
      - urbanforest-network
volumes:
  data:

#Docker Networks
networks:
  urbanforest-network:
    driver: bridge

